#include<bits/stdc++.h>

using namespace std;

#define mp(x,y) make_pair(x, y)
#define For(i, n) for (int i = 0; i < (int) n; i++)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define MOD 1000000007

ll modexp(ll base, ll expon) {
    ll res = 1, sq = base;
    while (expon > 0) {
        if (expon % 2) {
            res *= sq;
            res %= MOD;
        }
        sq *= sq;
        sq %= MOD;
        expon /= 2;
    }
    return res;
}

void processAfter(vector<vector<ll> >& counts, vector<vector<ll> >& after) {
    For(i, 3) For(j, 3) counts [i][j] = after [i][j] % MOD;
}

void updateT(vector<vector<ll> >& counts) {
    vector<vector<ll> > after(3, vector<ll>(3, 0));
    For(j, 3) {
        after [0][j] = counts [2][j];
        after [1][j] = 2 * counts [1][j] + counts [0][j];
        after [2][j] = counts [2][j];
    }

    processAfter(counts, after);
}

void updateB(vector<vector<ll> >& counts) {
    vector<vector<ll> > after(3, vector<ll>(3, 0));
    For(j, 3) {
        after [2][j] = counts [0][j];
        after [1][j] = 2 * counts [1][j] + counts [2][j];
        after [0][j] = counts [0][j];
    }

    processAfter(counts, after);
}

void updateL(vector<vector<ll> >& counts) {
    vector<vector<ll> > after(3, vector<ll>(3, 0));
    For(i, 3) {
        after [i][0] = counts [i][2];
        after [i][1] = 2 * counts [i][1] + counts [i][0];
        after [i][2] = counts [i][2];
    }

    processAfter(counts, after);
}

void updateR(vector<vector<ll> >& counts) {
    vector<vector<ll> > after(3, vector<ll>(3, 0));
    For(i, 3) {
        after [i][2] = counts [i][0];
        after [i][1] = 2 * counts [i][1] + counts [i][2];
        after [i][0] = counts [i][0];
    }

    processAfter(counts, after);
}

void solve() {
    int n;
    cin >> n;
    string s, c;
    cin >> s;
    cin >> c;
    sort(c.begin(), c.end());
    vector<vector<ll> > counts(3, vector<ll>(3, 0));
    if (c == "BT"){
        cout << (modexp(2, count(s.begin(), s.end(), 'L') + count(s.begin(), s.end(), 'R')) + 1) % MOD << '\n';
        return;
    }
    else if (c == "LR") {
        cout << (modexp(2, count(s.begin(), s.end(), 'T') + count(s.begin(), s.end(), 'B')) + 1) % MOD << '\n';
        return;
    }
    else if (c == "BL") {
        counts [2][0] = 1;
    }
    else if (c == "BR") {
        counts [2][2] = 1;
    }
    else if (c == "LT") {
        counts [0][0] = 1;
    }
    else if (c == "RT") {
        counts [0][2] = 1;
    }
    reverse(s.begin(), s.end());
    for (char fold : s) {
        switch (fold) {
            case 'T': {
                updateT(counts);
                break;
            }
            case 'B': {
                updateB(counts); 
                break;
            }
            case 'L': {
                updateL(counts); 
                break;
            }
            case 'R': {
                updateR(counts); 
                break;
            }
        }
    }
    ll res = 1;
    For(i, 3) For(j, 3) res += counts [i][j];
    res %= MOD;
    cout << res << '\n';
}

int main () {
    int t;
    cin >> t;
    For(i, t) solve();
}
